<?php if (!defined('BASEPATH')) exit('No direct script access allowed');
/**
 * XtraUpload
 *
 * A turn-key open source web 2.0 PHP file uploading package requiring PHP v5
 *
 * @package		XtraUpload
 * @author		Matthew Glinski
 * @copyright	Copyright (c) 2006, XtraFile.com
 * @license		http://xtrafile.com/docs/license
 * @link		http://xtrafile.com
 * @since		Version 2.0
 * @filesource
 */

// ------------------------------------------------------------------------

/**
 * XtraUpload Upload Page Language File
 *
 * @package		XtraUpload
 * @subpackage	Language
 * @category	Language
 * @author		Matthew Glinski
 * @link		http://xtrafile.com/docs/language
 */

// ------------------------------------------------------------------------

$lang['legal_tos_headertitle'] = 'Terms of Service';
$lang['legal_tos_header'] = 'Web Site Terms and Conditions of Use';
$lang['legal_tos_terms_header'] = '1. Terms';
$lang['legal_tos_terms_1'] = 'By accessing this web site, you are agreeing to be bound by these 
	web site Terms and Conditions of Use, all applicable laws and regulations, 
	and agree that you are responsible for compliance with any applicable local 
	laws. If you do not agree with any of these terms, you are prohibited from 
	using or accessing this site. The materials contained in this web site are 
	protected by applicable copyright and trade mark law.';
$lang['legal_tos_license_header'] = '2. Use License';
$lang['legal_tos_license_p1_1'] = 'Permission is granted to temporarily download one copy of the materials 
		(information or software) on ';
$lang['legal_tos_license_p1_2'] = '\'s web site for personal, 
		non-commercial transitory viewing only. This is the grant of a license, 
		not a transfer of title, and under this license you may not:';
$lang['legal_tos_license_p2_1'] = 'modify or copy the materials;';
$lang['legal_tos_license_p2_2'] = 'use the materials for any commercial purpose, or for any public display (commercial or non-commercial);';
$lang['legal_tos_license_p2_3'] = 'attempt to decompile or reverse engineer any software contained on ';
$lang['legal_tos_license_p2_3_1'] = '\'s web site;';
$lang['legal_tos_license_p2_4'] = 'remove any copyright or other proprietary notations from the materials; or';
$lang['legal_tos_license_p2_5'] = 'transfer the materials to another person or "mirror" the materials on any other server.';
$lang['legal_tos_license_p3_1'] = 'This license shall automatically terminate if you violate any of these restrictions and may be terminated by <?=$site_name?> at any time. Upon terminating your viewing of these materials or upon the termination of this license, you must destroy any downloaded materials in your possession whether in electronic or printed format.';
$lang['legal_tos_disclaimer_header'] = '3. Disclaimer';
$lang['legal_tos_disclaimer_p1'] = 'The materials on ';
$lang['legal_tos_disclaimer_p1_1'] = '\'s web site are provided "as is". ';
$lang['legal_tos_disclaimer_p1_2'] = ' makes no warranties, expressed or implied, and hereby disclaims and negates all other warranties, including without limitation, implied warranties or conditions of merchantability, fitness for a particular purpose, or non-infringement of intellectual property or other violation of rights. Further, ';
$lang['legal_tos_disclaimer_p1_3'] = ' does not warrant or make any representations concerning the accuracy, likely results, or reliability of the use of the materials on its Internet web site or otherwise relating to such materials or on any sites linked to this site.';
$lang['legal_tos_limitations_header'] = '4. Limitations';
$lang['legal_tos_limitations_p1'] = 'In no event shall ';
$lang['legal_tos_limitations_p1_1'] = ' or its suppliers be liable for any damages (including, without limitation, damages for loss of data or profit, or due to business interruption,) arising out of the use or inability to use the materials on ';
$lang['legal_tos_limitations_p1_2'] = '\'s Internet site, even if ';
$lang['legal_tos_limitations_p1_3'] = ' or a ';
$lang['legal_tos_limitations_p1_4'] = ' authorized representative has been notified orally or in writing of the possibility of such damage. Because some jurisdictions do not allow limitations on implied warranties, or limitations of liability for consequential or incidental damages, these limitations may not apply to you.';
$lang['legal_tos_revisions_header'] = '5. Revisions and Errata';
$lang['legal_tos_revisions_p1'] = 'The materials appearing on ';
$lang['legal_tos_revisions_p1_1'] = '\'s web site could include technical, typographical, or photographic errors. ';
$lang['legal_tos_revisions_p1_2'] = ' does not warrant that any of the materials on its web site are accurate, complete, or current. ';
$lang['legal_tos_revisions_p1_3'] = ' may make changes to the materials contained on its web site at any time without notice. ';
$lang['legal_tos_revisions_p1_4'] = ' does not, however, make any commitment to update the materials.';
$lang['legal_tos_links_header'] = '6. Links';
$lang['legal_tos_links_p1'] = ' has not reviewed all of the sites linked to its Internet web site and is not responsible for the contents of any such linked site. The inclusion of any link does not imply endorsement by ';
$lang['legal_tos_links_p1_1'] = ' of the site. Use of any such linked web site is at the user\'s own risk.';
$lang['legal_tos_terms_header'] = '7. Site Terms of Use Modifications';
$lang['legal_tos_terms_p1'] = ' may revise these terms of use for its web site at any time without notice. By using this web site you are agreeing to be bound by the then current version of these Terms and Conditions of Use.';
$lang['legal_tos_governing_header'] = '8. Governing Law';
$lang['legal_tos_governing_p1'] = 'Any claim relating to ';
$lang['legal_tos_governing_p1_1'] = '\'s web site shall be governed by the laws of the United States of America without regard to its conflict of law provisions.';

$lang['legal_privacy_headertitle'] = 'Privacy Policy';
$lang['legal_privacy_header'] = 'Privacy Policy';
$lang['legal_privacy_1'] = 'Your privacy is very important to us. Accordingly, we have developed this Policy in order for you to understand how we collect, use, communicate and disclose and make use of personal information. The following outlines our privacy policy.';
$lang['legal_privacy_2'] = 'Before or at the time of collecting personal information, we will identify the purposes for which information is being collected.';
$lang['legal_privacy_3'] = 'We will collect and use of personal information solely with the objective of fulfilling those purposes specified by us and for other compatible purposes, unless we obtain the consent of the individual concerned or as required by law.';
$lang['legal_privacy_4'] = 'We will only retain personal information as long as necessary for the fulfillment of those purposes.';
$lang['legal_privacy_5'] = 'We will collect personal information by lawful and fair means and, where appropriate, with the knowledge or consent of the individual concerned.';
$lang['legal_privacy_6'] = 'Personal data should be relevant to the purposes for which it is to be used, and, to the extent necessary for those purposes, should be accurate, complete, and up-to-date.';
$lang['legal_privacy_7'] = 'We will protect personal information by reasonable security safeguards against loss or theft, as well as unauthorized access, disclosure, copying, use or modification.';
$lang['legal_privacy_8'] = 'We will make readily available to customers information about our policies and practices relating to the management of personal information.';
$lang['legal_privacy_9'] = 'We are committed to conducting our business in accordance with these principles in order to ensure that the confidentiality of personal information is protected and maintained.';